<template>
  <div class="genres-step">
    <div class="genres-header">
      <a href="#" @click="skipStep">{{
        $t('modal.preference.genresStep.skip')
      }}</a>
      <h4 class="heading--lg heading--primary heading--uppercase">
        {{ $t('modal.preference.genresStep.title') }}
      </h4>
      <ul class="list-dots">
        <li class="previous-step" @click="previousStep">
          <a href="#"></a>
        </li>
        <li class="active"></li>
      </ul>
    </div>
    <div>
      <div class="step_inner">
        <p v-html="$t('modal.preference.genresStep.text')"></p>
      </div>
      <Loader :display="loading" />
      <ul v-if="genresList.length > 0" class="genres-list content-to-display">
        <li
          v-for="genre in genresList"
          :key="`genre-${genre.id}`"
          @click="selectGenre(genre.id)"
        >
          <AppButton
            :ref="`selected-${genre.id}`"
            :theme="btnTheme"
            :genre="genre.id"
          >
            {{ genre.name }}
          </AppButton>
        </li>
      </ul>

      <div class="step_actions">
        <strong>{{ $t('modal.preference.genresStep.or') }}</strong>
        <AppButton
          :ref="`selected-0`"
          :theme="btnTheme"
          style="margin-left: 15px"
          @click="selectGenre('0')"
          >{{ $t('modal.preference.genresStep.allGenres') }}</AppButton
        >
      </div>
    </div>
    <div>
      <section class="section-alternative">
        <p>
          {{ $t('modal.preference.genresStep.text-save') }}
        </p>

        <div class="checkbox-alt">
          <input
            id="field-agree"
            :ref="`field-agree`"
            type="checkbox"
            name="field-agree"
            @click="setAgreed"
          />

          <label class="field-agree" for="field-agree" @click="setAgreed">
            <span></span>
            {{ $t('modal.preference.genresStep.text-agree') }}
          </label>
        </div>
      </section>
      <br />
      <div class="step__actions step__actions--alt text--center">
        <AppButton
          :ref="`save-preference`"
          :theme="`disable`"
          @click="savePreference"
          >{{ $t('modal.preference.genresStep.btn') }}</AppButton
        >
      </div>
    </div>
  </div>
</template>

<script>
import AppButton from '@/components/ui/AppButton'
import Loader from '@/components/ui/Loader'

export default {
  name: 'GenresStep',
  components: { AppButton, Loader },
  props: {
    shelves: {
      type: Array,
      required: true
    }
  },
  data() {
    return {
      loading: true,
      genresList: [],
      genresSelected: [],
      agreed: false
    }
  },
  computed: {
    btnTheme() {
      return 'select'
    }
  },
  async mounted() {
    const data = await this.$api.getGenresListByShelves(this.shelves)
    if (data) {
      this.genresList = data
      this.loading = false

      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'PopIn',
        EventAction: 'Preference-Genres',
        EventLabel: 'Affichage_genres'
      })
    }
  },
  methods: {
    previousStep() {
      this.$emit('get-step', 'shelves-step')
    },
    savePreference() {
      if (this.genresSelected.length > 0 && this.agreed) {
        this.$utils.gtmEvent({
          event: 'gtm.event',
          EventCategory: 'PopIn',
          EventAction: 'Preference-Genres',
          EventLabel: `Clic_(${this.getSelectedGenres().join(', ')})`
        })
        const data = {
          shelves: this.shelves,
          genres: this.genresSelected
        }
        const result = this.$api.saveUserPreference(data)
        if (result) {
          this.$emit('close')
        }
      }
    },
    selectGenre(genreId) {
      if (genreId !== '') {
        if (genreId === '0') {
          if (!this.genresSelected.includes(genreId)) {
            if (this.genresSelected.length > 0) {
              this.genresSelected.forEach((v) => {
                this.$refs[`selected-${v}`][0].$el.classList.replace(
                  'active',
                  'select'
                )
              })
            }
            this.genresSelected = []
            this.genresSelected.push(genreId)
            this.$refs[`selected-${genreId}`].$el.classList.replace(
              'select',
              'active'
            )
          }
        } else {
          if (
            this.genresSelected.length > 0 &&
            this.genresSelected[0] === '0'
          ) {
            this.genresSelected = []
            this.$refs['selected-0'].$el.classList.replace('active', 'select')
          }
          if (this.genresSelected.includes(genreId)) {
            this.genresSelected.splice(this.genresSelected.indexOf(genreId), 1)
            this.$refs[`selected-${genreId}`][0].$el.classList.replace(
              'active',
              'select'
            )
          } else {
            this.genresSelected.push(genreId)
            this.$refs[`selected-${genreId}`][0].$el.classList.replace(
              'select',
              'active'
            )
          }
        }
        this.checkGenres()
      }
    },
    skipStep() {
      const data = {
        shelves: 'skip',
        genres: 'skip'
      }
      const result = this.$api.saveUserPreference(data)
      if (result) {
        this.$emit('display-modal')
        this.$emit('close')
      }
    },
    setAgreed() {
      this.$refs[`field-agree`].checked
        ? (this.agreed = true)
        : (this.agreed = false)
      this.checkGenres()
    },
    checkGenres() {
      if (this.genresSelected.length > 0 && this.agreed) {
        this.$refs[`save-preference`].$el.classList.remove('disable')
      } else {
        this.$refs[`save-preference`].$el.classList.add('disable')
      }
    },
    getSelectedGenres() {
      const selectedIds = this.genresSelected
      return this.genresList
        .filter((v) => selectedIds.indexOf(v.id) >= 0)
        .map((v) => v.name)
    }
  }
}
</script>

<style lang="scss">
.genres-step {
  text-align: left;

  .genres-header {
    a {
      float: right;
      font-size: 20px;
    }
  }

  .step {
    &_inner {
      font-size: 25px;
    }

    &_actions {
      strong {
        font-size: 25px;
      }
    }
  }

  .genres-list {
    margin: 20px 0;
    list-style-type: none;
    li {
      display: inline-block;
      flex: 0 0 auto;
      margin: 0 10px 20px;

      .select,
      .active {
        padding: 12px 16px;
        font-size: 16px;
        font-weight: 700;
      }
    }
  }

  .field-agree {
    margin: 15px 0 !important;
    font-weight: 400;
    color: #ff641e;
  }

  .section-alternative {
    background-color: #fef7eb;
    color: unset;
    margin-top: 25px;
    padding: 20px;
    p {
      font-size: 25px;
      font-weight: 800;
      margin: unset;
      padding-left: unset;
    }
  }

  .step_actions {
    margin: 20px 0;
    list-style-type: none;

    label {
      margin-left: 25px;
      @include screen-size(md) {
        margin-left: unset;
        margin-top: 10px !important;
      }
    }
  }

  input[type='checkbox']:not(:checked),
  input[type='checkbox']:checked {
    position: absolute !important;
    -webkit-appearance: checkbox;
  }

  [type='checkbox']:not(:checked) + label,
  [type='checkbox']:checked + label {
    position: relative;
    padding-left: 25px;
    cursor: pointer;
  }
}
</style>
